com/urls.py
from django.urls import path
from . import views

app_name = 'com'
urlpatterns = [
    path('', views.inbox, name='inbox'),
    path('message/<id_topic>', views.message, name='message'),
    path('contacter/', views.contact, name='contact'),
]

com/models.py
from django.contrib.auth.models import User
from django.db import models

from offers.models import Offer


class Topic(models.Model):
    id_offer = models.ForeignKey(Offer, on_delete=models.CASCADE)
    subject = models.CharField(max_length=50)
    id_sender = models.ForeignKey(
        User, on_delete=models.CASCADE, related_name='topic_sender')
    id_recipient = models.ForeignKey(
        User, on_delete=models.CASCADE, related_name='topic_recipient')

    def __str__(self):
        return self.subject


class Message(models.Model):
    id_sender = models.ForeignKey(
        User, on_delete=models.CASCADE, related_name='sender')
    id_topic = models.ForeignKey(Topic, on_delete=models.CASCADE)
    content = models.CharField(max_length=500)
    date = models.DateField(auto_now=False, auto_now_add=True)

com/forms.py
from django.forms import Form, ModelForm, Textarea
from com.models import Message, Topic

class MessageForm(ModelForm):
    class Meta:
        model = Message
        fields = ['content']

        labels = {'content': 'Message'}

        widgets = {
            'content': Textarea(
                attrs={
                    'cols': 40,
                    'rows': 10,
                    'class': 'form-control',
                    'placeholder': ' '
                }
            )
        }

com/views.py
from django.contrib.auth.decorators import login_required
from django.contrib.auth.models import User
from django.db.models import Q
from django.shortcuts import get_object_or_404, redirect, render

from com.forms import MessageForm
from com.models import Topic
from offers.models import Offer


@login_required(login_url='/auth/signin/')
def inbox(request):
    user = request.user

    # Get all topics related to current user
    topics = Topic.objects.filter(Q(id_sender=user) | Q(id_recipient=user))

    context = {
        'topics': topics
    }
    return render(request, 'com/inbox.html', context)


@login_required(login_url='/auth/signin/')
def contact(request):
    try:
        request.session['offer_id']
        request.session['offer_user']
    except KeyError:
        return redirect('/')

    if request.method == 'POST':
        form = MessageForm(request.POST)

        if form.is_valid():
            offer_id = request.session.pop('offer_id')
            offer_user_id = request.session.pop('offer_user')

            sender = request.user
            recipient = get_object_or_404(User, id=offer_user_id)
            offer = get_object_or_404(Offer, id=offer_id)

            subject = request.POST['subject']
            new_topic = Topic(
                id_offer=offer,
                id_sender=sender,
                id_recipient=recipient,
                subject=subject
            )
            new_topic.save()
            new_message = form.save(commit=False)
            new_message.id_topic = new_topic
            new_message.id_sender = sender
            new_message.save()

            return redirect('com:inbox')
    else:
        form = MessageForm()

    context = {
        'form': form,
    }

    return render(request, 'com/topic.html', context)


@login_required(login_url='/auth/signin/')
def message(request, id_topic):
    # From given topic, get all messages
    topic = get_object_or_404(Topic, id=id_topic)
    messages = topic.message_set.all()

    if request.method == 'POST':
        form = MessageForm(request.POST)

        if form.is_valid():
            user = request.user
            new_message = form.save(commit=False)
            new_message.id_topic = topic
            new_message.id_sender = user
            new_message.save()

            return redirect(request.path)
    else:
        form = MessageForm()

    context = {
        'topic': topic,
        'messages': messages,
        'form': form,
    }

    return render(request, 'com/message.html', context)

com/templates/com/inbox.html
{% extends 'sirmo/base.html' %}
{% load static %}
{% block content %}
<section>
  <div class="container">
    {% for topic in topics  %}
    <div class="row justify-content-center">
      <div class="col-lg-7 col-md-12">
        <div class="container inbox">
          <div class="row">
            <div class="col-2 col-inbox">
              <div class="image-view-inbox">
                <img class="img-fluid image-inbox" src="{% static 'sirmo/img/mail.png' %}"
                  alt="Doggo">
              </div>
            </div>
            <div class="col-10 align-self-center">
              <div class="row">
                <div class="col-4">

                  {% if topic.id_sender == request.user %}
                  {{ topic.id_recipient.first_name }}
                  {% else %}
                  {{ topic.id_sender.first_name }}
                  {% endif %}

                </div>
                <div class="col-8">
                  <a href="{% url 'com:message' topic.id %}">
                    <div>
                      {{ topic.subject }}
                    </div>
                  </a>
                </div>
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>
    {% endfor %}
  </div>
</section>
{% endblock content %}

com/templates/com/message.html
{% extends 'sirmo/base.html' %}
{% block content %}
<section>
  <div class="container">
    <div class="row justify-content-center">
      <div class="col-lg-6">
        <form action="{% url 'com:message' topic.id %}" method="post">
          {% csrf_token %}
          {% for field in form %}
          <div class="form-group">
            <label>{{ field.label }}</label>
            {{ field }}
            {% if field.help_text %}
            <p class="help-inline"><small>{{ field.help_text }}</small></p>
            {% endif %}
          </div>
          {% endfor %}
          <input class="btn btn-primary" type="submit" value="Envoyer">
        </form>
      </div>
    </div>
    <div class="row justify-content-center">
      <div class="col-lg-8 col-md-12">

        <div class="container inbox message">
          {% for message in messages %}
          {% if message.id_sender == request.user %}

          <div class="row message-border-left">
            <div class="col-3">
              <div class="content message">
                {{ message.id_sender.first_name }}
              </div>
            </div>
            <div class="col-9">
              <div class="content message">
                {{ message.content }}
              </div>
            </div>
          </div>
          {% else %}

          <div class="row message-border-right">
            <div class="col-9 text-right">
              <div class="content message">
                {{ message.content }}
              </div>
            </div>
            <div class="col-3 text-right">
              <div class="content message">
                {{ message.id_sender.first_name }}
              </div>
            </div>
          </div>

          {% endif %}
          {% endfor %}
        </div>
      </div>
    </div>
  </div>
</section>
{% endblock content %}

com/templates/com/topic.html
{% extends 'sirmo/base.html' %}
{% block content %}
<section>
  <div class="container">
    <div class="row justify-content-center">
      <div class="col-lg-6">
        <form action="{% url 'com:contact' %}" method="post">
          {% csrf_token %}
          <div class="form-group">
            <label>Sujet</label>
            <input type="text" name="subject" maxlength="50" class="form-control" required="" id="id_subject">
          </div>
          {% for field in form %}
          <div class="form-group">
            <label>{{ field.label }}</label>
            {{ field }}
            {% if field.help_text %}
            <p class="help-inline"><small>{{ field.help_text }}</small></p>
            {% endif %}
          </div>
          {% endfor %}
          <input class="btn btn-primary" type="submit" value="Envoyer">
        </form>
      </div>
    </div>
    <div class="row justify-content-center">
      <div class="col-lg-8 col-md-12">

        {% for message in messages %}
        {% if message.id_sender == request.user %}
        <div class="container inbox message">
          <div class="row">
            <div class="col-3">
              <div class="content message">
                {{ message.id_sender.first_name }}
              </div>
            </div>
            <div class="col-9">
              <div class="content message">
                {{ message.content }}
              </div>
            </div>
          </div>
        </div>

        {% else %}
        <div class="container inbox message">
          <div class="row">
            <div class="col-9 text-right">
              <div class="content message">
                {{ message.content }}
              </div>
            </div>
            <div class="col-3 text-right">
              <div class="content message">
                {{ message.id_sender.first_name }}
              </div>
            </div>
          </div>
        </div>
        {% endif %}
        {% endfor %}

      </div>
    </div>
  </div>
</section>
{% endblock content %}